/*
	** pageSet 1.0
	** https://blog.redinfo.co.kr/cdn/load?key=js/pageset.js
	** license - REDINFO (https://blog.redinfo.co.kr)
	** Copyright (C) 2022 redinfo.co.kr
	** Notice
		- 재배포, 수정 자유 
		- 단 주석은 유지
	** Contact 
		- webmaster@redinfo.co.kr 
		- lcy@redinfo.co.kr
 */
$.fn.pageset = function(option){
	if( typeof option != 'object'){ option = {}; }
	__pagesetObj.$object = $(this);
	if( typeof option.on ==  'object'){
		if( !option.on.load){ option.on.load =__pagesetObj.option.on.load;  }
		if( !option.on.pagesetToStart){  option.on.pagesetToStart = __pagesetObj.option.on.pagesetToStart;  }
		if( !option.on.pagesetToEnd){ option.on.pagesetToEnd = __pagesetObj.option.on.pagesetToEnd;  }
		if( !option.on.pagesetPrev){ option.on.pagesetPrev = __pagesetObj.option.on.pagesetPrev;  }
		if( !option.on.pagesetNext){ option.on.pagesetNext = __pagesetObj.option.on.pagesetNext;  }
		if( !option.on.resize){ option.on.resize = __pagesetObj.option.on.resize;  }
		if( !option.on.complete){ option.on.complete = __pagesetObj.option.on.complete;  }
	}
	__pagesetObj.option = Object.assign(__pagesetObj.option, option);
	__pagesetObj.method.eventLoad();
	__pagesetObj.method.load();
	__pagesetObj.option.on.load();

	__pagesetObj.$object.pagesetPrev = __pagesetObj.method.pagesetPrev;
	__pagesetObj.$object.pagesetNext = __pagesetObj.method.pagesetNext;
	__pagesetObj.$object.pagesetTo = __pagesetObj.method.pagesetTo;
	__pagesetObj.$object.el = __pagesetObj;

	return __pagesetObj.$object;
};

var __pagesetObj = {
	$object : {},
	active : false, 
	activeResize : false,
	activeEvent : '', /* wheel, touch, keyboard, mouse ,scroll */
	activeSetTimout : false,
	boxHeight : 0, 
	boxLength : 0,
	currentIndex : 0,
	maxIndex : 0,
	state : 'load',
	event : {},
	eventStack : {},
	option : {
		speed : 500,
		startSpeed : 0,
		mode : 'transition', /* transition or scroll */
		touchmoving : true,
		mousemoving : true,
		sboxClass : '.sbox',
		sboxLastHeight : 'auto', /* auto, window height */
		sboxLastSpeed : false, /*  last item speed, false or (number) */
		debug : false,
		hash : false,
		easing : 'swing', /* if mode is scroll use */
		on : {
			load : function(){},	
			pagesetToStart : function(){},
			pagesetToEnd : function(){},
			pagesetPrev : function(){},
			pagesetNext : function(){},
			resize : function(){},
			complete : function(){},
		}
	},
	method : {
		eventLoad :function(){
			var thisEl = __pagesetObj;
			thisEl.event.pagesetToStart = $.Event("pagesetToStart", {});
			thisEl.event.pagesetToEnd = $.Event("pagesetToEnd", {});
			thisEl.event.pagesetNext = $.Event("pagesetNext", {});
			thisEl.event.pagesetPrev = $.Event("pagesetPrev", {});
			thisEl.event.resize = $.Event("resize", {});
			thisEl.event.complete = $.Event("complete", {});
		},		
		load : function(){
			var thisEl = __pagesetObj;
			var wh = $(window).outerHeight();

			/*속성초기화*/
			$('html,body').css('height','100%');
			thisEl.maxIndex = $(thisEl.option.sboxClass).length-1;
			$(thisEl.option.sboxClass).each(function(i,v){
				var thisWh = wh;
				if( i==0){  thisEl.boxHeight = wh; }
				if( i==thisEl.maxIndex && thisEl.option.sboxLastHeight != 'auto' && parseInt(thisEl.option.sboxLastHeight) > 0 ){ thisWh = parseInt(thisEl.option.sboxLastHeight); }
				$(v).height(thisWh).data({'index':i,'hash':'#'+i}).attr({'data-index':i,'data-hash':'#'+i});
			});
			$(thisEl.option.sboxClass).each(function(i,v){
				var data = $(v).data();
			});

			/* 마우스 휠/스크롤에 따른 이벤트*/
			if( thisEl.option.mode == 'transition'){
				$('html,body').css('overflow-y','hidden');
				$(window).unbind('wheel').bind('wheel', function(event){ event.stopPropagation(); thisEl.method.eventWheel(event); });
			}else{ 
				$('html,body').css('overflow-y','auto'); 
				$(window).unbind('wheel').bind('wheel', function(event){ event.stopPropagation(); thisEl.method.eventScroll(event); });
			} 

			/*키보드 업다운 이벤트 */
			$(window).unbind('keyup').bind('keyup', function(event){ event.stopPropagation(); thisEl.method.eventKeyboard(event); });

			/*터치이벤트*/
			var tt =0;
			var tde = false; var ts ; 
			$('html, body').unbind('touchstart').bind('touchstart', function(event){
			  event.stopPropagation();
			  ts = event.originalEvent.touches[0].clientY;
			  if( thisEl.option.touchmoving === true) { tde = true; } 
			  tt = thisEl.$object.position().top
			});
			$('html, body').unbind('touchmove').bind('touchmove', function(event){
			  	event.stopPropagation();
				var $object = thisEl.$object;
				var oh = thisEl.$object.innerHeight();
				var tm = event.originalEvent.touches[0].clientY;
				if( tde === true){
					move = tt-(ts-tm);
					if( thisEl.option.mode == 'transition'){
						$object.attr('style',' height:100%; position:relative;touch-action: none; transform: translate3d(0px, '+move+'px, 0px); transition:none');
					}else{
						$object = $('html,body');
						animateOption = {scrollTop:(move*-1)+'px'};
						$object.stop().animate(animateOption,0,thisEl.option.easing);						
					}
				}
			});		
			$('html, body').unbind('touchend').bind('touchend', function(event){
				event.stopPropagation();
				tde = false;
				thisEl.method.eventTouch(event,ts);
			});
			
			var mt = 0;
			var mde = false; var md ;  
			$('html, body').unbind('mousedown').bind('mousedown', function(event){
				event.stopPropagation();
				var $object = thisEl.$object;
				md = event.originalEvent.clientY;
				if( thisEl.option.mousemoving === true) { mde = true; } 
				mt = thisEl.$object.position().top
			});
			window.document.ondragstart = new Function("return false");
			$('html, body').unbind('mousemove').bind('mousemove', function(event){
				event.stopPropagation();
				var $object = thisEl.$object;
				var oh = thisEl.$object.innerHeight();
				var mm = event.originalEvent.clientY;
				if( mde === true){
					move = mt-(md-mm);

					if( thisEl.option.mode == 'transition'){
						$object.attr('style',' height:100%; position:relative;touch-action: none; transform: translate3d(0px, '+move+'px, 0px); transition:none');
					}else{
						$object = $('html,body');
						animateOption = {scrollTop:(move*-1)+'px'};
						$object.stop().animate(animateOption,0,thisEl.option.easing);
					}
					
				}
				
			});		
			/*마우스 드래그 업다운*/
			$('html, body').unbind('mouseup').bind('mouseup', function(event){
				event.stopPropagation();
				mde = false;
				var chk = thisEl.method.eventMouse(event,md);

			});		

			/*리사이징 이벤트*/
			$(window).unbind('resize').bind('resize',function(){
				thisEl.method.resize();
			});

			/*해시 및 초기화 이벤트 */
			if( thisEl.option.hash === true){

				/* index 초기화 */	
				var index = location.hash.replace("#","");
				if(!index) index = 0;		
				if( index >= thisEl.maxIndex){ index = thisEl.maxIndex; }

				thisEl.method.pagesetTo(index,thisEl.option.startSpeed);
			}else{
				var rsUrl = document.baseURI;
				if(document.location.hash){
					rsUrl = rsUrl.replace(document.location.hash,"");
				}
				history.replaceState(null,null,rsUrl);
			}

			thisEl.method.debug('on init');
		},
		eventMouse : function(event,md){
			var thisEl = __pagesetObj;
			thisEl.activeEvent = 'mouse';

			var chkIndex = 0;
			$('.sbox').each(function(i,v){
				var s = $(v).offset().top;
				if( s > 0){ chkIndex = i;   return false; }
			});
			
			var mu = event.originalEvent.clientY;
			var dvIndex = thisEl.currentIndex;
			if( md < mu){ dvIndex -=1; }
			if( md > mu){ dvIndex +=1; }
			if( dvIndex <= 0){ dvIndex = 0; }
			else if( dvIndex > thisEl.maxIndex ){ dvIndex = thisEl.maxIndex; }

			var dv = $(thisEl.option.sboxClass+'[data-index="'+dvIndex+'"]').height()/4;

			if(md < (mu - (dv) )){
		        thisEl.method.pagesetPrev();			
		        thisEl.method.debug('eventMouse : mouse drag up');			
			} else if(md > (mu + (dv) )){
		        thisEl.method.pagesetNext();		
		        thisEl.method.debug('eventMouse : mouse drag down');			
			}else{
				thisEl.method.pagesetTo(thisEl.currentIndex,thisEl.option.speed);
			}
			thisEl.state = 'eventMouse';
		},	
		eventTouch : function(event,ts){
			var thisEl = __pagesetObj;
			thisEl.activeEvent = 'touch';
			var te = event.originalEvent.changedTouches[0].clientY;

			var dv = 5;
			if(ts < ( te - (dv) )  ){
		        thisEl.method.pagesetPrev();			
		        thisEl.method.debug('eventTouch : touch up');		
			} else if(ts > (te + (dv) )  ){
		        thisEl.method.pagesetNext();		
		        thisEl.method.debug('eventTouch : touch down');		
			}else{
				thisEl.method.pagesetTo(thisEl.currentIndex,thisEl.option.speed);
			}
			thisEl.state = 'eventTouch';
		},
		eventScroll:function(event){
			var thisEl = __pagesetObj;
			thisEl.activeEvent = 'scroll';
		    if (event.originalEvent.wheelDelta > 0 || event.originalEvent.detail < 0) {
		        thisEl.method.pagesetPrev();
		        thisEl.method.debug('eventScroll : scroll up');	
		    }
		    else {
		        thisEl.method.pagesetNext();
		        thisEl.method.debug('eventScroll : scroll down');	
		    }
		    thisEl.state = 'eventScroll';
		},
		eventWheel:function(event){
			var thisEl = __pagesetObj;
			thisEl.activeEvent = 'wheel';
		    if (event.originalEvent.wheelDelta > 0 || event.originalEvent.detail < 0) {
		        thisEl.method.pagesetPrev();
		        thisEl.method.debug('eventWheel : wheel up');	
		    }
		    else {
		        thisEl.method.pagesetNext();
		        thisEl.method.debug('eventWheel : wheel down');	
		    }
		    thisEl.state = 'eventWheel';

		},
		eventKeyboard : function(event){
			var thisEl = __pagesetObj;
			thisEl.activeEvent = 'keyboard';
			if( event.keyCode == 38){ 
		        thisEl.method.pagesetPrev();
		        thisEl.method.debug('eventKeyboard : key up');	
			}else if(event.keyCode == 40){ 
		        thisEl.method.pagesetNext();
		        thisEl.method.debug('eventKeyboard : key down');	
			}
			thisEl.state = 'eventKeyboard';
		},
		pagesetPrev :function(speed){
			var thisEl = __pagesetObj;
			if( thisEl.active !== false  ){  
				if( $.inArray(thisEl.state, ['eventMouse','eventTouch']) !== -1 ){
					thisEl.method.pagesetTo(thisEl.currentIndex,speed);
				}
				return false
			}
			thisEl.active = true;
			if( typeof speed == 'undefined'){ speed = thisEl.option.speed; }
	        var index = thisEl.currentIndex-1;
	        if( index <= 0){ index = 0; }
			thisEl.method.pagesetTo(index,speed);
			thisEl.method.debug('pagesetPrev : index of '+index+' , speed set '+speed);
			thisEl.state = 'pagesetPrev';
			thisEl.$object.trigger(thisEl.event.pagesetPrev);
			thisEl.option.on.pagesetPrev();
		},
		pagesetNext :function(speed){
			var thisEl = __pagesetObj;
			if( thisEl.active !== false  ){  
				if( $.inArray(thisEl.state, ['eventMouse','eventTouch']) !== -1 ){
					thisEl.method.pagesetTo(thisEl.currentIndex,speed);
				}
				return false
			}
			thisEl.active = true;
			if( typeof speed == 'undefined'){ speed = thisEl.option.speed; }
	        var index = thisEl.currentIndex+1; 
	        if( index >= thisEl.maxIndex){ index = thisEl.maxIndex; }
			thisEl.method.pagesetTo(index,speed);
			thisEl.method.debug('pagesetNext : index of '+index+' , speed set '+speed);	
			thisEl.state = 'pagesetNext';
			thisEl.$object.trigger(thisEl.event.pagesetNext);
			thisEl.option.on.pagesetNext();
		},

		pagesetTo : function(index, speed){
			var thisEl = __pagesetObj;	
			if( typeof speed == 'undefined'){ speed = thisEl.option.speed; }

			thisEl.$object.trigger(thisEl.event.pagesetToStart);
			thisEl.option.on.pagesetToStart();

			index = parseInt(index);
			var height= $(thisEl.option.sboxClass+'[data-index="'+index+'"]').outerHeight();
			var firstHeight= $(thisEl.option.sboxClass+'[data-index="0"]').outerHeight();
			var top = 0;
			$(thisEl.option.sboxClass).each(function(i,v){
				if( i == 0){ return true; }
				if( index == (i-1)){ return false; }
				top += $(v).height();
			});

			var animateOption = {};
			var $object = {};

			if( index == thisEl.maxIndex && thisEl.option.sboxLastSpeed !== false && thisEl.state != 'load' ){ speed = thisEl.option.sboxLastSpeed; }
			if( thisEl.option.mode == 'transition'){
				animateOption = {top:(top*-1)+'px'};
				$object = thisEl.$object;

				$object.attr('style','transform: translate3d(0px, '+(top*-1)+'px, 0px); transition: all '+speed+'ms ease 0s;');
				thisEl.activeSetTimout = setTimeout(function(){
					thisEl.active = false;
					if( thisEl.currentIndex != index){
						thisEl.currentIndex = index;
						thisEl.method.complete();
					}
				},speed);

			}else{
				animateOption = {scrollTop:(top*1)+'px'};
				$object = $('html,body');
				$object.stop().animate(animateOption,speed,thisEl.option.easing,function(){
					thisEl.active = false;
					if( thisEl.currentIndex != index){
						thisEl.currentIndex = index;
						thisEl.method.complete();
					}
				});		

			}

		
			/*해시 사용여부에 따른 처리*/
			if( thisEl.option.hash === true){
				window.location.href = "#"+index;
			}
			thisEl.state = 'pagesetTo';

			thisEl.method.debug('pagesetTo : index of '+index+' , speed set '+speed);	
			thisEl.$object.trigger(thisEl.event.pagesetToEnd);
			thisEl.option.on.pagesetToEnd();

			
		},
		complete :function(){
			var thisEl = __pagesetObj;
			thisEl.method.debug('complete');
			thisEl.state = 'complete';

			thisEl.$object.trigger(thisEl.event.complete);
			thisEl.option.on.complete();

			/* complete 후에 stack 에 쌓인 내용을 업데이트해준다. */
		},
		resize : function(){

			var thisEl = __pagesetObj;
			if( thisEl.state == 'resize') { return false; }
			var wh = $(window).outerHeight();
			$(thisEl.option.sboxClass).each(function(i,v){
				var thisWh = wh;
				if( i==0){  thisEl.boxHeight = wh; }
				if( i==thisEl.maxIndex && thisEl.option.sboxLastHeight != 'auto' && parseInt(thisEl.option.sboxLastHeight) > 0 ){ thisWh = parseInt(thisEl.option.sboxLastHeight); }
				$(v).height(thisWh);			
				
			});
			thisEl.activeResize = true;
			thisEl.method.pagesetTo(thisEl.currentIndex,0);
			thisEl.method.debug('resize');
			thisEl.state = 'resize';

			thisEl.$object.trigger(thisEl.event.resize);
			thisEl.option.on.resize();
		},
		debug : function(msg){
			var thisEl = __pagesetObj;

			if( thisEl.option.debug === true){
				console.log(msg, 'currentIndex:'+thisEl.currentIndex);
			}
		}
	}
};
